(define-library (snow bignum tests)
  (export run-tests)
  (import (scheme base)
          (snow bignum))
  (begin

    (define (run-tests)
      (and
       (equal? "123" (bignum->string (string->bignum "123")))
       (equal? "-123" (bignum->string (string->bignum "-123")))
       (bignum= (string->bignum "987654321") (string->bignum "987654321"))
       (bignum< (string->bignum "987654321") (string->bignum "987654322"))
       (bignum<= (string->bignum "987654321") (string->bignum "987654322"))
       (bignum> (string->bignum "987654321") (string->bignum "987654320"))
       (bignum>= (string->bignum "987654321") (string->bignum "987654320"))
       (bignum-zero? (string->bignum "0"))
       (not (bignum-zero? (string->bignum "123")))
       (bignum-negative? (string->bignum "-123"))
       (not (bignum-negative? (string->bignum "0")))
       (bignum-positive? (string->bignum "123"))
       (not (bignum-positive? (string->bignum "0")))
       (bignum-even? (string->bignum "10"))
       (bignum-even? (string->bignum "-10"))
       (not (bignum-even? (string->bignum "9")))
       (bignum-odd? (string->bignum "17"))
       (bignum-odd? (string->bignum "-17"))
       (not (bignum-odd? (string->bignum "10")))
       (bignum= (string->bignum "123")
                (bignum+ (string->bignum "115") (string->bignum "8")))
       (bignum= (string->bignum "5")
                (bignum+ (string->bignum "-4") (string->bignum "9")))
       (bignum= (string->bignum "100")
                (bignum- (string->bignum "115") (string->bignum "15")))
       (bignum= (string->bignum "-9")
                (bignum- (string->bignum "11") (string->bignum "20")))
       (bignum= (string->bignum "-731")
                (bignum* (string->bignum "-43") (string->bignum "17")))
       (bignum= (string->bignum "-58823")
                (bignum-quotient (string->bignum "1000000")
                                 (string->bignum "-17")))
       (bignum= (string->bignum "9")
                (bignum-remainder (string->bignum "1000000")
                                  (string->bignum "-17")))
       (bignum= (string->bignum "-8")
                (bignum-modulo (string->bignum "1000000")
                               (string->bignum "-17")))
       (bignum= (string->bignum "654321")
                (bignum-max (string->bignum "123456")
                            (string->bignum "654321")))
       (bignum= (string->bignum "123456")
                (bignum-min (string->bignum "123456")
                            (string->bignum "654321")))))))
